> For the complete documentation index, see [llms.txt](https://docs.zenlytic.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zenlytic.com/developers/user-attributes.md).

# User Attributes

## GET /workspaces/{workspace\_id}/user\_attribute\_definitions

> Get User Attribute Definitions

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"ApiV2CollectionResponse_UserAttributeDefinitionSchema_":{"properties":{"data":{"items":{"$ref":"#/components/schemas/UserAttributeDefinitionSchema"},"type":"array","title":"Data"},"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["data","meta"],"title":"ApiV2CollectionResponse[UserAttributeDefinitionSchema]"},"UserAttributeDefinitionSchema":{"properties":{"id":{"type":"string","title":"Id"},"workspace_id":{"type":"string","title":"Workspace Id"},"name":{"type":"string","title":"Name"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"label":{"type":"string","title":"Label"}},"type":"object","required":["id","workspace_id","name","data_type","label"],"title":"UserAttributeDefinitionSchema"},"UserAttributeDataType":{"type":"string","enum":["string","number","date"],"title":"UserAttributeDataType"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"},"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"}}},"paths":{"/workspaces/{workspace_id}/user_attribute_definitions":{"get":{"tags":["User Attributes"],"summary":"Get User Attribute Definitions","operationId":"get_user_attribute_definitions_workspaces__workspace_id__user_attribute_definitions_get","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2CollectionResponse_UserAttributeDefinitionSchema_"}}}},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## POST /workspaces/{workspace\_id}/user\_attribute\_definitions

> Create User Attribute Definition

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"CreateUserAttributeDefinitionSchema":{"properties":{"name":{"type":"string","title":"Name"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"label":{"type":"string","title":"Label"}},"type":"object","required":["name","data_type","label"],"title":"CreateUserAttributeDefinitionSchema"},"UserAttributeDataType":{"type":"string","enum":["string","number","date"],"title":"UserAttributeDataType"},"ApiV2Response_UserAttributeDefinitionSchema_":{"properties":{"data":{"$ref":"#/components/schemas/UserAttributeDefinitionSchema"},"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["data","meta"],"title":"ApiV2Response[UserAttributeDefinitionSchema]"},"UserAttributeDefinitionSchema":{"properties":{"id":{"type":"string","title":"Id"},"workspace_id":{"type":"string","title":"Workspace Id"},"name":{"type":"string","title":"Name"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"label":{"type":"string","title":"Label"}},"type":"object","required":["id","workspace_id","name","data_type","label"],"title":"UserAttributeDefinitionSchema"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"},"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"}}},"paths":{"/workspaces/{workspace_id}/user_attribute_definitions":{"post":{"tags":["User Attributes"],"summary":"Create User Attribute Definition","operationId":"create_user_attribute_definition_workspaces__workspace_id__user_attribute_definitions_post","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateUserAttributeDefinitionSchema"}}}},"responses":{"201":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2Response_UserAttributeDefinitionSchema_"}}}},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## DELETE /workspaces/{workspace\_id}/user\_attribute\_definitions/{user\_attribute\_definition\_id}

> Delete User Attribute Definition

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"}}},"paths":{"/workspaces/{workspace_id}/user_attribute_definitions/{user_attribute_definition_id}":{"delete":{"tags":["User Attributes"],"summary":"Delete User Attribute Definition","operationId":"delete_user_attribute_definition_workspaces__workspace_id__user_attribute_definitions__user_attribute_definition_id__delete","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}},{"name":"user_attribute_definition_id","in":"path","required":true,"schema":{"type":"string","title":"User Attribute Definition Id"}}],"responses":{"204":{"description":"Successful Response"},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## PATCH /workspaces/{workspace\_id}/user\_attribute\_definitions/{user\_attribute\_definition\_id}

> Update User Attribute Definition

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"UpdateUserAttributeDefinitionSchema":{"properties":{"label":{"type":"string","title":"Label"}},"type":"object","required":["label"],"title":"UpdateUserAttributeDefinitionSchema"},"ApiV2Response_UserAttributeDefinitionSchema_":{"properties":{"data":{"$ref":"#/components/schemas/UserAttributeDefinitionSchema"},"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["data","meta"],"title":"ApiV2Response[UserAttributeDefinitionSchema]"},"UserAttributeDefinitionSchema":{"properties":{"id":{"type":"string","title":"Id"},"workspace_id":{"type":"string","title":"Workspace Id"},"name":{"type":"string","title":"Name"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"label":{"type":"string","title":"Label"}},"type":"object","required":["id","workspace_id","name","data_type","label"],"title":"UserAttributeDefinitionSchema"},"UserAttributeDataType":{"type":"string","enum":["string","number","date"],"title":"UserAttributeDataType"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"},"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"}}},"paths":{"/workspaces/{workspace_id}/user_attribute_definitions/{user_attribute_definition_id}":{"patch":{"tags":["User Attributes"],"summary":"Update User Attribute Definition","operationId":"update_user_attribute_definition_workspaces__workspace_id__user_attribute_definitions__user_attribute_definition_id__patch","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}},{"name":"user_attribute_definition_id","in":"path","required":true,"schema":{"type":"string","title":"User Attribute Definition Id"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateUserAttributeDefinitionSchema"}}}},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2Response_UserAttributeDefinitionSchema_"}}}},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## GET /workspaces/{workspace\_id}/members/{member\_id}/user\_attributes

> Get Member User Attributes

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"ApiV2CollectionResponse_UserAttributeSchema_":{"properties":{"data":{"items":{"$ref":"#/components/schemas/UserAttributeSchema"},"type":"array","title":"Data"},"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["data","meta"],"title":"ApiV2CollectionResponse[UserAttributeSchema]"},"UserAttributeSchema":{"properties":{"id":{"type":"string","title":"Id"},"user_attribute_definition_id":{"type":"string","title":"User Attribute Definition Id"},"value":{"type":"string","title":"Value"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"name":{"type":"string","title":"Name"},"source":{"$ref":"#/components/schemas/UserAttributeSource"},"source_id":{"type":"string","title":"Source Id"},"user_attribute_precedence":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"User Attribute Precedence"},"is_overridden":{"type":"boolean","title":"Is Overridden"}},"type":"object","required":["id","user_attribute_definition_id","value","data_type","name","source","source_id","user_attribute_precedence","is_overridden"],"title":"UserAttributeSchema"},"UserAttributeDataType":{"type":"string","enum":["string","number","date"],"title":"UserAttributeDataType"},"UserAttributeSource":{"type":"string","enum":["user","group"],"title":"UserAttributeSource"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"},"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"}}},"paths":{"/workspaces/{workspace_id}/members/{member_id}/user_attributes":{"get":{"tags":["User Attributes"],"summary":"Get Member User Attributes","operationId":"get_member_user_attributes_workspaces__workspace_id__members__member_id__user_attributes_get","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}},{"name":"member_id","in":"path","required":true,"schema":{"type":"string","title":"Member Id"}}],"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2CollectionResponse_UserAttributeSchema_"}}}},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## POST /workspaces/{workspace\_id}/members/{member\_id}/user\_attributes

> Create Member User Attribute

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"CreateUserAttributeSchema":{"properties":{"user_attribute_definition_id":{"type":"string","title":"User Attribute Definition Id"},"value":{"type":"string","title":"Value"}},"type":"object","required":["user_attribute_definition_id","value"],"title":"CreateUserAttributeSchema"},"ApiV2Response_UserAttributeSchema_":{"properties":{"data":{"$ref":"#/components/schemas/UserAttributeSchema"},"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["data","meta"],"title":"ApiV2Response[UserAttributeSchema]"},"UserAttributeSchema":{"properties":{"id":{"type":"string","title":"Id"},"user_attribute_definition_id":{"type":"string","title":"User Attribute Definition Id"},"value":{"type":"string","title":"Value"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"name":{"type":"string","title":"Name"},"source":{"$ref":"#/components/schemas/UserAttributeSource"},"source_id":{"type":"string","title":"Source Id"},"user_attribute_precedence":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"User Attribute Precedence"},"is_overridden":{"type":"boolean","title":"Is Overridden"}},"type":"object","required":["id","user_attribute_definition_id","value","data_type","name","source","source_id","user_attribute_precedence","is_overridden"],"title":"UserAttributeSchema"},"UserAttributeDataType":{"type":"string","enum":["string","number","date"],"title":"UserAttributeDataType"},"UserAttributeSource":{"type":"string","enum":["user","group"],"title":"UserAttributeSource"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"},"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"}}},"paths":{"/workspaces/{workspace_id}/members/{member_id}/user_attributes":{"post":{"tags":["User Attributes"],"summary":"Create Member User Attribute","operationId":"create_member_user_attribute_workspaces__workspace_id__members__member_id__user_attributes_post","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}},{"name":"member_id","in":"path","required":true,"schema":{"type":"string","title":"Member Id"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateUserAttributeSchema"}}}},"responses":{"201":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2Response_UserAttributeSchema_"}}}},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## DELETE /workspaces/{workspace\_id}/members/{member\_id}/user\_attributes/{user\_attribute\_id}

> Delete Member User Attribute

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"}}},"paths":{"/workspaces/{workspace_id}/members/{member_id}/user_attributes/{user_attribute_id}":{"delete":{"tags":["User Attributes"],"summary":"Delete Member User Attribute","operationId":"delete_member_user_attribute_workspaces__workspace_id__members__member_id__user_attributes__user_attribute_id__delete","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}},{"name":"member_id","in":"path","required":true,"schema":{"type":"string","title":"Member Id"}},{"name":"user_attribute_id","in":"path","required":true,"schema":{"type":"string","title":"User Attribute Id"}}],"responses":{"204":{"description":"Successful Response"},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```

## PATCH /workspaces/{workspace\_id}/members/{member\_id}/user\_attributes/{user\_attribute\_id}

> Update Group User Attribute

```json
{"openapi":"3.1.0","info":{"title":"FastAPI","version":"0.1.0"},"security":[{"HTTPBearer":[]},{"APIKeyHeader":[]}],"components":{"securitySchemes":{"HTTPBearer":{"type":"http","scheme":"bearer"},"APIKeyHeader":{"type":"apiKey","in":"header","name":"X-API-Key"}},"schemas":{"UpdateUserAttributeSchema":{"properties":{"value":{"type":"string","title":"Value"}},"type":"object","required":["value"],"title":"UpdateUserAttributeSchema"},"ApiV2Response_UserAttributeSchema_":{"properties":{"data":{"$ref":"#/components/schemas/UserAttributeSchema"},"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["data","meta"],"title":"ApiV2Response[UserAttributeSchema]"},"UserAttributeSchema":{"properties":{"id":{"type":"string","title":"Id"},"user_attribute_definition_id":{"type":"string","title":"User Attribute Definition Id"},"value":{"type":"string","title":"Value"},"data_type":{"$ref":"#/components/schemas/UserAttributeDataType"},"name":{"type":"string","title":"Name"},"source":{"$ref":"#/components/schemas/UserAttributeSource"},"source_id":{"type":"string","title":"Source Id"},"user_attribute_precedence":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"User Attribute Precedence"},"is_overridden":{"type":"boolean","title":"Is Overridden"}},"type":"object","required":["id","user_attribute_definition_id","value","data_type","name","source","source_id","user_attribute_precedence","is_overridden"],"title":"UserAttributeSchema"},"UserAttributeDataType":{"type":"string","enum":["string","number","date"],"title":"UserAttributeDataType"},"UserAttributeSource":{"type":"string","enum":["user","group"],"title":"UserAttributeSource"},"MetaSchema":{"properties":{"status":{"$ref":"#/components/schemas/ResponseStatus"},"errors":{"items":{"$ref":"#/components/schemas/ErrorSchema"},"type":"array","title":"Errors"},"warnings":{"items":{"$ref":"#/components/schemas/WarningSchema"},"type":"array","title":"Warnings"},"request_source":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Request Source"}},"type":"object","required":["status"],"title":"MetaSchema"},"ResponseStatus":{"type":"string","enum":["success","error"],"title":"ResponseStatus"},"ErrorSchema":{"properties":{"message":{"type":"string","title":"Message"},"status_code":{"anyOf":[{"type":"integer"},{"type":"null"}],"title":"Status Code"},"occurred_at":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Occurred At"},"error_code":{"anyOf":[{"type":"string"},{"type":"null"}],"title":"Error Code"},"error_metadata":{"anyOf":[{"$ref":"#/components/schemas/FieldAlreadyExistsErrorMetadata"},{"type":"null"}]}},"type":"object","required":["message"],"title":"ErrorSchema"},"FieldAlreadyExistsErrorMetadata":{"properties":{"existing_column_ids":{"items":{"type":"string"},"type":"array","title":"Existing Column Ids"}},"type":"object","required":["existing_column_ids"],"title":"FieldAlreadyExistsErrorMetadata"},"WarningSchema":{"properties":{"message":{"type":"string","title":"Message"}},"type":"object","required":["message"],"title":"WarningSchema"},"ApiV2ErrorResponse":{"properties":{"meta":{"$ref":"#/components/schemas/MetaSchema"}},"type":"object","required":["meta"],"title":"ApiV2ErrorResponse"}}},"paths":{"/workspaces/{workspace_id}/members/{member_id}/user_attributes/{user_attribute_id}":{"patch":{"tags":["User Attributes"],"summary":"Update Group User Attribute","operationId":"update_group_user_attribute_workspaces__workspace_id__members__member_id__user_attributes__user_attribute_id__patch","parameters":[{"name":"workspace_id","in":"path","required":true,"schema":{"type":"string","title":"Workspace Id"}},{"name":"member_id","in":"path","required":true,"schema":{"type":"string","title":"Member Id"}},{"name":"user_attribute_id","in":"path","required":true,"schema":{"type":"string","title":"User Attribute Id"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/UpdateUserAttributeSchema"}}}},"responses":{"200":{"description":"Successful Response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2Response_UserAttributeSchema_"}}}},"4XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Client Error"},"5XX":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiV2ErrorResponse"}}},"description":"Server Error"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zenlytic.com/developers/user-attributes.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
